﻿using System;
using UnityEngine;

namespace Power
{
    class AndroidHealPower : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            var limb = phys.GetComponent<LimbBehaviour>();

            if (limb != null && limb.IsAndroid == true)
            {
                limb.HealBone();
                limb.Health = limb.InitialHealth;
                limb.Wince(DampeningRadius);
                limb.Numbness = 0f;
                limb.CirculationBehaviour.HealBleeding();
                limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
                limb.CirculationBehaviour.BloodFlow = 5f;
                if (limb.CirculationBehaviour.GetAmount(limb.GetOriginalBloodType()) < 1f)
                {
                    limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), 0.2f);
                }
                limb.BruiseCount = 0;
                limb.CirculationBehaviour.GunshotWoundCount = 0;
                limb.CirculationBehaviour.StabWoundCount = 0;
                if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
                {
                    limb.Person.Consciousness = 1f;
                    limb.Person.ShockLevel = 0f;
                    limb.Person.PainLevel = 0f;
                    limb.Person.OxygenLevel = 1f;
                    limb.Person.AdrenalineLevel = 1f;
                }

                if (limb.PhysicalBehaviour.BurnProgress > 0.1f)
                {
                    limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.16f;
                }

                if(limb.SkinMaterialHandler.AcidProgress > 0.1f)
                {
                    limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.8f;
                }

                if(limb.SkinMaterialHandler.RottenProgress > 0.1f)
                {
                    limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.8f;
                }
            }
        }

        public override float Radius
        {
            get
            {
                return 5f;
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 1f;
            }
        }
    }
}
