﻿using System;
using UnityEngine;
using System.Collections;

namespace Power
{
    // Token: 0x0200012D RID: 301
    public class FireWorks : AOEPowerTool
    {
        // Token: 0x0600077C RID: 1916 RVA: 0x00027EC4 File Offset: 0x000260C4
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            var limb = phys.GetComponent<LimbBehaviour>();

            if (limb != null)
            {
                
                var boom = phys.gameObject.GetOrAddComponent<ExplosiveBehaviour>();
                boom.ArmOnAwake = true;
                boom.DestroyOnExplode = true;
                boom.Delay = 2;
            }
            Vector2 vector = Global.main.MousePosition - phys.transform.position;
            phys.rigidbody.AddForce((this.GetFalloff(this.Force, vector.sqrMagnitude, this.MaxForce) * Vector2.up + this.GetFalloff(0.1f, vector.sqrMagnitude, 0.1f) * this.mouseMovement) * phys.rigidbody.mass, ForceMode2D.Force);
        }

        public override float Radius
        {
            get
            {
                return 2f;
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 1f;
            }
        }
        // Token: 0x0600077D RID: 1917 RVA: 0x00027F57 File Offset: 0x00026157
        protected override GameObject CreateEffectObject()
        {
            return UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/Lift tool effect"));
        }
    }

}
