﻿using System;
using UnityEngine;

namespace Power
{
    class PainPower : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            var limb = phys.GetComponent<LimbBehaviour>();

            if (limb != null && limb.IsAndroid == false)
            {
                if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
                {
                    limb.Person.PainLevel = 1f;
                }
            }
        }

        public override float Radius
        {
            get
            {
                return 5f;
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 1f;
            }
        }
    }
}
