﻿using System;
using UnityEngine;

namespace Power
{
    class PressurePower : AOEPowerTool
    {
        protected override void HandleObject(PhysicalBehaviour phys)
        {
            var pos = Global.main.MousePosition - phys.transform.position;
            var mag = pos.magnitude;
            var limb = phys.GetComponent<LimbBehaviour>();

            if (limb != null)
            {
                if (mag < DampeningRadius)
                {
                    limb.PhysicalBehaviour.rigidbody.gravityScale += 0.05f;
                }
                limb.PhysicalBehaviour.rigidbody.gravityScale += 0.05f;
                limb.Wince(DampeningRadius);
              
            }
        }

        public override float Radius
        {
            get
            {
                return 5f;
            }
        }

        public override float DampeningRadius
        {
            get
            {
                return 1f;
            }
        }
    }
}
