﻿using UnityEngine;

namespace Mod
{
    internal class StringWireTool : DistanceWireTool
    {
		public void Awake()
		{
			WireMaterial = Resources.Load<Material>("Materials/Wire");
			WireMaterial.color = Color.white;
			WireWidth = 0.01f;
			
		}

		protected override void OnJointCreate(DistanceJoint2D joint)
		{
			StringBehaviour stringBehaviour = joint.gameObject.AddComponent<StringBehaviour>();
			UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(stringBehaviour, "string"));
			stringBehaviour.WireColor = WireColor;
			stringBehaviour.WireMaterial = WireMaterial;
			stringBehaviour.WireWidth = WireWidth;

			stringBehaviour.typedJoint = joint;
			stringBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable(joint, 700f, 1f, 1f);
		}

		private class StringBehaviour : DistanceJointWireBehaviour
		{
			protected float breakForceBuffer = 1f;

			public override void Slice()
			{
				breakForceBuffer = 0f;
			}

			protected override void Start()
			{
				
				base.Start();
				breakForceBuffer = base.currentBreakingForce;
				if (lineRenderer.startColor == LegacyColour)
				{
					base.SetColor(Color.white);
				}
			}

			protected override void Created()
			{
				WireColor = Color.white;
				lineRenderer.startColor = Color.white;
				lineRenderer.endColor = Color.white;
				lineRenderer.numCapVertices = 0;
			}
		}
    }
}