﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

namespace Power
{
    class TimeStop : MonoBehaviour
    {

        public float TimeBeforeAffected; //The time after the object spawns until it will be affected by the timestop(for projectiles etc)
        private Rigidbody2D rb;
        private Vector2 recordedVelocity;
        private float recordedMagnitude;
        private float recordedang;
        private float recordegravity;
        private float recordedrag;
        private float recordedAngular;
        private float recordeangularDrag;
        private float TimeBeforeAffectedTimer;
        private bool CanBeAffected;
        public Boolean stop = false;

        public Boolean recorded = false;


        void Start()
        {
            rb = GetComponent<Rigidbody2D>();
            TimeBeforeAffectedTimer = TimeBeforeAffected;
        }

        void FixedUpdate()
        {
            TimeBeforeAffectedTimer -= Time.deltaTime; // minus 1 per second
            if (TimeBeforeAffectedTimer <= 0f)
            {
                CanBeAffected = true; // Will be affected by timestop
            }

            if (stop == true)
            {
                if (rb.velocity.magnitude >= 0f) //If Object is moving
                {
                    if(recorded == false)
                    {
                        recordedVelocity = rb.velocity; //records direction of movement
                        recordedAngular = rb.angularVelocity;
                        recordedrag = rb.drag;
                        recordeangularDrag = rb.angularDrag;
                        recorded = true;
                    }




                    rb.AddForce(Physics2D.gravity * rb.mass * -1f * rb.gravityScale);
                    float num = Mathf.Pow(0.2f, Mathf.Max(2f, 20f));
                    rb.velocity *= Vector2.zero;
                    rb.angularVelocity *= 0f;
                    rb.drag = 100f;
                    //rb.gravityScale = 0f;
                    rb.angularDrag = 100f;
                    stop = true;
                }
            }

        }
        public void ContinueTime()
        {
            
            stop = false;
            rb.velocity = recordedVelocity;
            rb.angularVelocity = recordedAngular;
            rb.drag = recordedrag;
            //rb.gravityScale = recordegravity;
            rb.angularDrag = recordeangularDrag;
            recorded = false;
        }
    }


}
